
/*   IBS,RSI,CCI    ,     , 
    (  IBS    ,     ).
       IBS,RSI,CCI .
             ,
          .
   Shift    (Shift    ).
"_1"    1  2.    2 --> "_1 = false".
"positive"   .      --> "positive = true".*/
//+------------------------------------------------------------------+
//|                                               IBS_RSI_CCI_v4.mq4 |
//|                                                       Martingeil |
//+------------------------------------------------------------------+
#property copyright "Martingeil"
#property link      "fx.09@mail.ru"
 
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red   //  0 -  
#property indicator_color2 Blue  //  1 -  VKWB
#property indicator_width1 2
#property indicator_width2 2
#property indicator_level1 0.0
//----    -------------------------------
extern ENUM_TIMEFRAMES    TimeFrame    = PERIOD_CURRENT;
extern int      per_IBS  =   5; // IBS
extern int      per_RSI  =  14; // RSI 
extern int      per_CCI  =  14; // CCI
extern int      porog    =  50; //
//----    VKWB ---------------------------           
extern int      RangePeriod_VKWB  = 25;
extern int      SmoothPeriod_VKWB =  3; 
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern bool   alertNotify     = true;
//------------------------------------------------------------
double koef_ibs = 7.0;
double koef_rsi = 9.0;
double koef_cci = 1.0;
int  = 0;//     
int app_price_RSI = 0;//app_price
int app_price_CCI = 0;//app_price
bool ibs = true;// ibs    
bool rsi = true;// rsi    
bool cci = true;// cci    
bool _1 = false;//   ,    2-          
int Shift = 0;//  
bool positive = true;// 
int SmoothMode_VKWB = 0;//  VKWB
//------------------------------------------------------------          
//---- buffers
double E0[], E1[], E2[], E3[], E4[], E5[], E6[], E7[];
int kibs=-1,kcci=-1,krsi=-1,posit=-1,xma1=1;
//------------------------------------------------------------
string indicatorFileName;
bool   returnBars;
int init(){
//---- indicators
   IndicatorBuffers(8); 
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,E0);
   SetIndexStyle(1,DRAW_LINE); 
   SetIndexBuffer(1,E7); 

   SetIndexBuffer(2,E1);   
   SetIndexBuffer(3,E2);
   SetIndexBuffer(4,E3);
   SetIndexBuffer(5,E4);  
   SetIndexBuffer(6,E5);
   SetIndexDrawBegin(6,SmoothPeriod_VKWB);   
   SetIndexBuffer(7,E6);
   SetIndexDrawBegin(7,SmoothPeriod_VKWB); 
        
   if(cci)kcci=1; if(rsi)krsi=1; if(ibs)kibs=1; 
   if(_1)xma1=0; if(positive)posit=1;   
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
   
//----       
return(0);}
//------------------------------------------------------------
int deinit(){return(0);}
//------------------------------------------------------------
double trend[];
int start()
  {
   int  cb=IndicatorCounted();
//----
   int i,r,limit,limit1,limit2,n_max,n_min;
   if(cb==0){limit=Bars-1; limit1=Bars-RangePeriod_VKWB; limit2=limit1-SmoothPeriod_VKWB;}
   if(cb>0) {limit=Bars-cb; limit1=Bars-cb; limit2=limit1;}  
   limit--;limit1--;limit2--;
   if (ArraySize(trend)!=Bars) ArrayResize(trend,Bars);
         if (returnBars) { E0[0] = MathMin(MathMax(MathMax(limit+1,limit1+1),limit2+1),Bars-1); return(0); }
         if (TimeFrame != _Period)
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
            for(i = limit; i >= 0; i--)
            {
               int y = iBarShift(NULL,TimeFrame,Time[i]);
                  E0[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,per_IBS,per_RSI,per_CCI,porog,RangePeriod_VKWB,SmoothPeriod_VKWB,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertNotify,0,y);
                  E7[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,per_IBS,per_RSI,per_CCI,porog,RangePeriod_VKWB,SmoothPeriod_VKWB,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertNotify,1,y);
            }
            return(0);
         }

   
   Delitel(E2,limit);
   for(i=limit;i>=0;i--)
      {E1[i]=posit*iMA_IBS_RSI_CCI( E2,
                                    per_IBS , per_RSI      , per_CCI      ,
                                      , app_price_RSI, app_price_CCI,
                                    koef_ibs, koef_rsi     , koef_cci     ,
                                    kibs    , krsi         , kcci         ,
                                    i+Shift);                   
      }
   for(i = limit;i>=0;i--)
      {E0[i]=E0[i+1];
       double raz10=E1[i]-E0[i];      
       if(MathAbs(raz10)>porog) 
      {if(raz10>0) E0[i]=E1[i]-porog*xma1;
       if(raz10<0) E0[i]=E1[i]+porog*xma1;
      }         
      } 
   for(i=limit1; i>=0;i--)
      {n_max=ArrayMaximum(E0,RangePeriod_VKWB,i);
       n_min=ArrayMinimum(E0,RangePeriod_VKWB,i);
       E3[i]=E0[n_max];
       E4[i]=E0[n_min];
      }
   for(i=limit2; i>=0;i--)
      {E5[i]=iMAOnArray(E3,0,SmoothPeriod_VKWB,0,SmoothMode_VKWB,i);
       E6[i]=iMAOnArray(E4,0,SmoothPeriod_VKWB,0,SmoothMode_VKWB,i);
      }   
   for(i=limit, r=Bars-i-1; i>=0;i--,r++)
      {
         E7[i]=(E5[i]+E6[i])/2;
         trend[r] = trend[r-1];
            if (E0[i]>E7[i]) trend[r] =  1;
            if (E0[i]<E7[i]) trend[r] = -1;
      }                             
      manageAlerts();
//----
return(0);}
//------------------------------------------------------------
void Delitel(double& ExtMapBuffer[],int limit)
{
 double delitel;
 for(int i=limit;i>=0;i--)
    {delitel=High[i]-Low[i];
     if (delitel>0)  ExtMapBuffer[i]=(Close[i]-Low[i])/delitel;
     else ExtMapBuffer[i]=0.0;
    }
return;}
//------------------------------------------------------------ 
double iMA_IBS_RSI_CCI(double ExtMapBuffer[],
                      int per_IBS,int per_RSI,int per_CCI,
                      int ,int app_price_RSI,int app_price_CCI,
                      double koef_ibs,double koef_rsi,double koef_cci,
                      int kibs,int krsi,int kcci,
                      int i)
{
 double sum=0.0;
 sum+=kibs*(iMAOnArray(ExtMapBuffer,0,per_IBS,0,MODE_SMA,i)-0.5)*100.0*koef_ibs;
 sum+=kcci*iCCI(NULL,0,per_CCI,app_price_CCI,i)*koef_cci; 
 sum+=krsi*(iRSI(NULL,0,per_RSI,app_price_RSI,i)-50.0)*koef_rsi;
 sum*=1.0/3.0; 
return(sum);}
//------------------------------------------------------------

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = Bars-whichBar-1;
      if (trend[whichBar] != trend[whichBar-1])
      {
         if (trend[whichBar] ==  1) doAlert("up");
         if (trend[whichBar] == -1) doAlert("down");
      }
   }
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message = timeFrameToString(_Period)+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" IBS RSI CCI trend changed to "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," IBS RSI CCI trend "),message);
          if (alertsSound)   PlaySound("alert2.wav");
          if (alertNotify)   SendNotification(message);
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}